﻿using Infragistics.Windows.DataPresenter;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Windows;
using System.Windows.Data;
using Infragistics.Windows.Editors;

namespace IgDataGridFormatBug
{

    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            Loaded += MainWindow_Loaded;
        }

        private FieldLayout GetFieldLayout()
        {
            var fl = new FieldLayout();

            var fields = new List<Field>()
            {
                new Field()
                {
                    Name = "Unexpected Behaviour",
                    BindingType = BindingType.UseAlternateBinding,
                    AlternateBinding = new Binding("A"),
                    Format = "",
                    EditAsType = typeof(decimal?),
                },

                new Field()
                {
                    Name = "Only with Format",
                    BindingType = BindingType.UseAlternateBinding,
                    AlternateBinding = new Binding("A"),
                    Format = ""
                },

                new Field()
                {
                    Name = "Only with EditAsType",
                    BindingType = BindingType.UseAlternateBinding,
                    AlternateBinding = new Binding("A"),
                    EditAsType = typeof(decimal?),
                },
            };

            fields.ForEach(fl.Fields.Add);

            return fl;
        }

        private void MainWindow_Loaded(object sender, RoutedEventArgs e)
        {
            xdg.FieldLayouts.Add(GetFieldLayout());
            xdg.DataSource = GetData(70).ToList();
        }

        private static IEnumerable<Data> GetData(int nrOfElements)
        {
            for (int i = 0; i < nrOfElements; i++)
            {
                yield return new Data
                {
                    A = i % 2 == 0 ? 1m : 0m, // reduce the amount of possible Numbers
                };
            }
        }

        internal class Data
        {
            public decimal? A { get; set; }
        }
    }
}